

#include "fila.h"
#include "menu.h"


//Imprime opes menu
void imprime_menu(){
     printf("Menu : \n"); 
     printf("IU\t insere usuario:\t IU <nome> <tipo> (sem espacos)\n");     
     printf("CU\t consulta usuarios:\t CU \n");
     printf("IC\t insere carro :\t\t IC <carro> <marca> <potencia>\n");
     printf("CC\t consulta carro :\t CC \n");
     printf("RC\t reserva carro: \t RC <cod carro> <cod usuario>\n");
     printf("AC\t aluga carro: \t\t AC <cod carro> <cod usuario> (sem espacos)\n");
     printf("DC\t devolve carro: \t\t <cod carro>\n");
     printf("PR\t proximo na reserva:\t PR <cod carro>\n");

     printf("FE\t finaliza execucao:\t FE\n");
  }
     
void menu(){
   int erro,ncarros=0 ,nusuarios=0,codusuario,codcarro, i,auxuser=0 ,auxcarro=0;
    Carro carros[30];
    Usuario usuarios[50];
    Fila reservacarros[30];
    char opcao[3];

    for (i=0;i<30;i++) Create(&reservacarros[i]);
    
    do{
      //imprime a cada interao o menu
      imprime_menu();
      printf("\n");
      
      //le a opo desejada de interao do menu
      scanf("%s",opcao);
      
      //le as informaes de um usuario (nome e tipo(locatario, funcionario, qualquer string,etc)
      if(!strcmp(opcao,"IU")){//insere usurio: IU <nome> <tipo> (sem espacos)
        scanf("%s %s",usuarios[nusuarios].nome,usuarios[nusuarios].tipo);
        nusuarios++;
      }
      
      //imprime o vetor que contem todos os usuarios
      else if(!strcmp(opcao,"CU")){//consulta usuario: CU
        for (auxuser=0;auxuser<nusuarios;auxuser++){
          printf("Codigo: %d\nNome: %s\nTipo: %s\n",auxuser,usuarios[auxuser].nome,usuarios[auxuser].tipo);
          printf("\n\n");
        }
      }
      
      //insere um carro com todos seus atributos, inicialmente sem usuario locatario(-1)
      else if(!strcmp(opcao,"IC")){//insere carro: IL <nome> <autor> (sem espacos)
        scanf("%s %s %s",carros[ncarros].nome,carros[ncarros].marca,carros[ncarros].potencia); 
        carros[ncarros].usuario=-1;                                   
        ncarros++;
      }
      
      //imprime o vetor que contem todos os carros, e para cada carro todas as suas reservas ( neste caso , todos os elementos da fila de reservas)
      else if(!strcmp(opcao,"CC")){//consulta Carros: CC
        for (auxcarro=0;auxcarro<ncarros;auxcarro++){
          printf("Codigo: %d\nNome: %s\nMarca: %s\nPotencia: %s\nAlugado: %d \nReservas:",auxcarro,carros[auxcarro].nome,carros[auxcarro].marca,carros[auxcarro].potencia,carros[auxcarro].usuario);
         Imprime(&reservacarros[auxcarro]);
          printf("\n\n");
        }
      }
   
      //Reserva um carro para um usuario , inserindo na fila de reserva do carro especifico para o usuario especifico (entra na fila)
      else if(!strcmp(opcao,"RC")){//reserva carro: RC <cod livro> <cod usuario>
        scanf("%d %d",&codcarro,&codusuario);
        Entra(&reservacarros[codcarro],&codusuario,&erro);
      }

      //Aluga um carro, com o id do locatario
      else if(!strcmp(opcao,"AC")){//aluga carro: AC <cod carro> <cod usuario>
        scanf("%d %d",&codcarro,&codusuario);
        carros[codcarro].usuario=codusuario;
      }
      // Devolve um carro , neste caso basta informar o id do carro
      else if(!strcmp(opcao,"DC")){//devolve carro: DC <cod carro>
        scanf("%d",&codcarro);
        carros[codcarro].usuario=-1;
      }
      
      //Retira o primeiro usuario que foi inserido na fila de reserva
      else if(!strcmp(opcao,"PR")){//prximo na reserva: PR <cod carro>
        scanf("%d",&codcarro);
        Sai(&reservacarros[codcarro],&codusuario,&erro);
        printf("Proximo na fila: %d\n",codusuario);
      }
      
       printf("\n");
    }while(strcmp(opcao,"FE"));//finaliza execuo: FE
}

